// gfx.c
// Created 10/3/95
// Copyright 1995 John Schultz
// All Rights Reserved

#include "imath.h"
#include "vector.h"
#include "gfx.h"
#include "vgfx.h"
#include "dramgfx.h"

volatile gfxType gfx={0};

void setGfxRender(gfxRender gr) {
  switch (gr) {
    case GFX_RENDER_VRAM:
      gfx.setDisplayMode = v_setDisplayMode;
      gfx.setPixel       = v_setPixel;
      gfx.drawLine       = v_drawLine;
      gfx.fillRect       = v_fillRect;
      gfx.clearPage      = v_clearPage;
      gfx.waitView       = v_waitView;
      gfx.updateView     = v_updateView;
      gfx.setViewPage    = v_setViewPage;
      gfx.setDrawPage    = v_setDrawPage;
      break;
    case GFX_RENDER_DRAM:
      gfx.setDisplayMode = d_setDisplayMode;
      gfx.setPixel       = d_setPixel;
      gfx.drawLine       = d_drawLine;
      gfx.fillRect       = d_fillRect;
      gfx.clearPage      = d_clearPage;
      gfx.waitView       = d_waitView;
      gfx.updateView     = d_updateView;
      gfx.setViewPage    = d_setViewPage;
      gfx.setDrawPage    = d_setDrawPage;
      break;
    case GFX_RENDER_DRAM_LCDBIOS:
      gfx.setDisplayMode = d_setDisplayModeLcdbios;
      gfx.setPixel       = d_setPixel;
      gfx.drawLine       = d_drawLine;
      gfx.fillRect       = d_fillRect;
      gfx.clearPage      = d_clearPage;
      gfx.waitView       = d_waitViewLcdbios;
      gfx.updateView     = d_updateViewLcdbios;
      gfx.setViewPage    = d_setViewPageLcdbios;
      gfx.setDrawPage    = d_setDrawPageLcdbios;
      break;
  } // switch
  (*gfx.setDisplayMode)(gfx.dispMode); // Keep current display mode
} // setGfxRender

void gfxPageHandler(long eye) {

// Update display pages
  if (gfx.dispMode == DISPLAY_STEREO) {
    if (gfx.advancePage) {
      gfx.advancePage = 0;
      if ((gfx.viewPage += 2) >= gfx.numPages) gfx.viewPage = 0;
    } // if
    (*gfx.setViewPage)(gfx.viewPage+eye);
  } else if (gfx.dispMode == DISPLAY_MONO) {
    if (gfx.advancePage) {
      gfx.advancePage = 0;
      if ((gfx.viewPage += 1) >= gfx.numPages) gfx.viewPage = 0;
      (*gfx.setViewPage)(gfx.viewPage);
    } // if
  } // if

} // gfxPageHandler

