// gfx.h
// created 4/19/94
// Copyright 1994 John Schultz
// All Rights Reserved

#ifndef GFX_H
#define GFX_H

typedef enum {
  GFX_RENDER_VRAM,
  GFX_RENDER_DRAM,
  GFX_RENDER_DRAM_LCDBIOS} gfxRender;
typedef enum {DRAW_LEFT,DRAW_RIGHT} gfxDrawLR;
typedef enum {DISPLAY_OFF,DISPLAY_MONO,DISPLAY_STEREO} displayMode;

typedef struct gfxType {
  displayMode dispMode;
  long numPages;
  long drawPage;
  long viewPage;
  long advancePage;
  void (*setPixel)(vec2 * p,long color);
  void (*drawLine)(vec2 * l,long color);
  void (*fillRect)(vec2 * extent,long color);
  void (*clearPage)(long color);
  void (*waitView)(void);
  void (*updateView)(void);
  void (*setViewPage)(long page);
  void (*setDrawPage)(gfxDrawLR dlr);
  void (*setDisplayMode)(displayMode dm);
} gfxType;

extern volatile gfxType gfx;

void setGfxRender(gfxRender gr);

void gfxPageHandler(long eye);

#endif

// gfx.h
