; isrStub.asm
; Created 10/10/95
; Copyright 1995 John Schultz
; All Rights Reserved

; Stub routine for int 8 timer. Calls sim18_2wEOI() and isrHandler()
; which are defined in vtimer.c.

.386p
                NAME    ISRSTUB
                EXTRN   isrHandler_ :BYTE
                EXTRN   sim18_2wEOI_:BYTE
DGROUP          GROUP   _DATA
_TEXT           SEGMENT PARA PUBLIC USE32 'CODE'
                ASSUME  CS:_TEXT,DS:DGROUP,SS:DGROUP
                PUBLIC  isrStub_

STACKSIZE       EQU     2048

isrStub_:
                pushad
                push    ds
                push    es
                push    fs
                push    gs

                cld

                mov     ax,DGROUP
                mov     ds,ax     ; get ds

                bts     dword ptr isrSemaLock,0h ; disallow reentrancy
                jnc     notLocked
                mov     al,20h
                out     20h,al    ; send an EOI and exit
                jmp     skipIsrHandler
notLocked:
                mov     ebp,esp               ; Watcom expects this...
                call    near ptr sim18_2wEOI_ ; EOI will be issued

                cli     ; make sure interrupts are disabled

                mov     word ptr oldSS,ss    ; save stack seg
                mov     dword ptr oldESP,esp ; save stack pointer

                lss     esp,fword ptr lsOff  ; load ss:esp (local stack)

                sti     ; enable interrupts

                mov     ebp,esp              ; Watcom expects this...
                call    near ptr isrHandler_ ; call user routines

                cli     ; make sure interrupts are disabled

                mov     esp,dword ptr oldESP ; restore stack pointer
                mov     ss,word ptr oldSS    ; restore stack segment

                mov     dword ptr isrSemaLock,0h ; clear semaphore lock

skipIsrHandler:
                pop     gs
                pop     fs
                pop     es
                pop     ds
                popad

                iretd

_TEXT           ENDS

_DATA           SEGMENT PARA PUBLIC USE32 'DATA'
oldSS           DW      0
oldESP          DD      0
isrSemaLock     DD      0
localStack      DB      STACKSIZE dup (?)
lsOff           DD      offset localStack+STACKSIZE
lsSeg           DW      DGROUP
_DATA           ENDS

                END
