#include <stdio.h>
#include <conio.h>
#include "joystick.h"
#include "vtimer.h"

#define MY_JOY_MAX_READ 2048

#define SOUND_DRIVER_CALL_RATE 120
#define VRR_MULTIPLIER 2
#define TIMER_ADVANCE_PERCENT (7.16/(float)VRR_MULTIPLIER) // 7.16

portInfo pi = {0};

void main() {
  long vrr;
  joyInfo ji;
  initJoystick(JOY_A|JOY_B_Y,MY_JOY_MAX_READ,INT_MASK_TIMER_0,0);

// Get the Vertical Refresh Rate (in Hz)
  vrr = getVRR();

// Init the timer system and LCD driver
  initLCDsys(vrr,
             TIMER_ADVANCE_PERCENT,
             VRR_MULTIPLIER,
             SOUND_DRIVER_CALL_RATE,
             0,
             0,
             &pi);



  while (!kbhit()) {
    long mcs = getMicroSecs();
    readJoystickTimer(&ji);
#if 1
    printf("A jx %5d jy %5d b1 %d b2 %d | B jx %5d jy %5d b1 %d b2 %d %.7f\n",
           ji.js[0].x,
           ji.js[0].y,
           ji.js[0].button[0],
           ji.js[0].button[1],
           ji.js[1].x,
           ji.js[1].y,
           ji.js[1].button[0],
           ji.js[1].button[1],
           (float)mcs/1e6
           );
#endif
  } // while
  getch();

  deInitLCDsys();

}
