; readjoy.asm
; Reads all joystick pots in one fast loop.
; All buttons are read.
; Written by Paul J. Radick
; Modified by John Schultz

        .386
        .MODEL  FLAT
	.DATA

_joyX1       dd  0
_joyY1       dd  0
_joyX2       dd  0
_joyY2       dd  0
_joyButtons  dd  0

	.CODE

        EXTRN   _joyMax : DWORD

        PUBLIC  _readJoy
        PUBLIC  _joyX1
        PUBLIC  _joyY1
        PUBLIC  _joyX2
        PUBLIC  _joyY2
        PUBLIC  _joyButtons

; Uses EAX, EDI, EBX, ECX, EDX
_readJoy         proc
	xor eax,eax
	mov ebx,eax
        mov _joyX1,eax
        mov _joyY1,eax
        mov _joyX2,eax
        mov _joyY2,eax

;        mov ecx,7FFFh
        mov ecx,dword ptr _joyMax

	mov edx,201h
;	pushfd

;	cli
	out dx,al
	in  al,dx

	not al
	shr eax,4
        mov _joyButtons,eax

LR_1:
	in  al,dx
	and eax,edi
	jz  LR_3

; Use the rotate with carry / add with carry trick for constant
; loop cycles.

	rcr al,1
        adc _joyX1,ebx
	rcr al,1
        adc _joyY1,ebx
	rcr al,1
        adc _joyX2,ebx
	rcr al,1
        adc _joyY2,ebx
	loop    LR_1
LR_2:
	mov eax,-1
LR_3:
;	popfd
	inc eax
	ret
_readJoy         endp
	end
