/* vgfx.h */
/* Created 1/13/95 */
/* Copyright 1995 John Schultz */
/* All Rights Reserved */

#ifndef VGFX_H
#define VGFX_H

#define VMODE_320x200_256 0x13

#define DCOLOR(r,g,b) (((b)*3/255)<<6)|(((g)*7/255)<<3)|((r)*7/255)
#define DAC(r,g,b) (((b)<<6)|((g)<<3)|(r))

void setOverscanColor(long color);

void setPalette(long * colors,long count);

void setVmode(long mode);

void restoreVmode(void);

void initXmode(void);

void deInitXmode(void);

void computeOffsets(void);

void setViewPageAddr(ulong addr);

void waitVS(void);

// Video memory page addresses
extern ulong vmpage[4];

// Video memory rendering routines:

void v_setDisplayMode(displayMode dm);
void v_setPixel(vec2 * p,long color);
void v_drawLine(vec2 * l,long color);
void v_fillRect(vec2 * extent,long color);
void v_clearPage(long color);
void v_waitView(void);
void v_updateView(void);
void v_setViewPage(long page);
void v_setDrawPage(gfxDrawLR dlr);

#endif

/* vgfx.h */
